﻿//~ Create CMYK Swatches
//~ This script creates swatches for printing using Adobe Illustrator
//~ It can vary the intensity and color.
//~ Color is defined in CMYK space.

//~ Copyright 2015 TechStar International Corp 
//~ www.vistalogics.com     
//~ 678-717-1200

var swatchLabel = "CMYK";
var tint = 100; 
var tintStart = 100;
var tintEnd = 100;
var tintStep = 0;

    function nthroot(x, n) {
	  try {
	    var negate = n % 2 == 1 && x < 0;
	    if(negate)
	      x = -x;
	    var possible = Math.pow(x, 1 / n);
	    n = Math.pow(possible, n);
	    if(Math.abs(x - n) < 1 && (x > 0 == n > 0))
	      return negate ? -possible : possible;
	  } catch(e){}
	}

 myDlg = new Window('dialog', "Create CMYK Swatches with Intensity Variation");
 myDlg.orientation = 'column';
 myDlg.alignment = 'right';

function createColorDialog()
{
with (myDlg.add('group'))
{
     
     orientation = 'row';
     add('statictext', undefined, "Intensity (0-100%) Start:");
     tintEdit = add('edittext', undefined, "100", {helpTip:"Color intensity"} );
     tintEdit.characters = 6;
     with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "End:");
               tintEndEdit = add('edittext', undefined, "100", {helpTip:"end of Intensity range"} );
               tintEndEdit.characters = 6;
          }
     with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "Steps:");
               tintStepEdit = add('edittext', undefined, "0", {helpTip:"Steps for Intensity range"} );
               tintStepEdit.characters = 6;
          }
}

with (myDlg.add('group'))
{
     orientation = 'row';
     with (add('panel'))
     {
          orientation = 'column';
          add('statictext', undefined, "Starting values");
          with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "Cyan");
               cyanEdit = add('edittext', undefined, "0", {helpTip:"Value of CYAN goes here"} );
               cyanEdit.characters = 6;
          }
          with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "Magenta");
               magEdit = add('edittext', undefined, "0", {helpTip:"Value of MAGENTA goes here"} );
               magEdit.characters = 6;
          }
          with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "Yellow");
               yelEdit = add('edittext', undefined, "0", {helpTip:"Value of YELLOW goes here"} );
               yelEdit.characters = 6;
          }
	  with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "Black");
               blkEdit = add('edittext', undefined, "0", {helpTip:"Value of BLACK goes here"} );
               blkEdit.characters = 6;
          }
     }
     with (add('panel'))
     {
          orientation = 'column';
          add('statictext', undefined, "Ending values");
          with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "Cyan");
               cyan2Edit = add('edittext', undefined, "100", {helpTip:"Put End value of CYAN in here"} );
               cyan2Edit.characters = 6;
          }
          with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "Magenta");
               mag2Edit = add('edittext', undefined, "100", {helpTip:"Put End value of MAGENTA in here"} );
               mag2Edit.characters = 6;
          }
          with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "Yellow");
               yel2Edit = add('edittext', undefined, "100", {helpTip:"Put End value of YELLOW in here"} );
               yel2Edit.characters = 6;
          }
           with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "Black");
               blk2Edit = add('edittext', undefined, "100", {helpTip:"Put End value of BLACK in here"} );
               blk2Edit.characters = 6;
          }
     }
    with (add('panel'))
     {
          orientation = 'column';
          add('statictext', undefined, "Steps");
          with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "Cyan");
               cyan3Edit = add('edittext', undefined, "4", {helpTip:"Number of CYAN steps"} );
               cyan3Edit.characters = 6;
          }
          with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "Magenta");
               mag3Edit = add('edittext', undefined, "4", {helpTip:"Number of MAGENTA steps"} );
               mag3Edit.characters = 6;
          }
          with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "Yellow");
               yel3Edit = add('edittext', undefined, "4", {helpTip:"Number of YELLOW steps"} );
               yel3Edit.characters = 6;
          }
	  with (add('group'))
          {
               orientation = 'row';
               add('statictext', undefined, "Black");
               blk3Edit = add('edittext', undefined, "4", {helpTip:"Number of BLACK steps"} );
               blk3Edit.characters = 6;
          }
     }
}
with (myDlg.add('group'))
{
     orientation = 'row';
     add('button', undefined, "OK", {helpTip:"Click to create color spread"});
     add('button', undefined, "Cancel", {helpTip:"Click to close this dialog"});
}

myDlg.add('statictext', undefined, "Copyright (c) 2011 VistaLogics Version 1.0");
tintEdit.active = true;
}

createColorDialog ();

function showColorDialog ()
{
   black = new GrayColor();
   black.gray = 100;
   tintStart=Math.max(Math.min(Number(tintEdit.text),100),0);
   tintEnd=Math.max(Math.min(Number(tintEndEdit.text),100),0);
   tintStep=Math.max(Math.min(Number(tintStepEdit.text),100),0);
   if (tintStart>tintEnd)
   {
     tint = tintEnd;
     tintEnd = tintStart;
     tintStart = tint;
    }
    if (tintStep <= 1)
     { 
        if (tintStart >= 0) {
           tintEnd = tintStart;
        } else {
           tintStart = tintEnd;
        }
      tintStep = 1;
     } else {
        tintStep = Math.max(Math.round((tintEnd-tintStart)/(tintStep-1)),1);
     }
  tintStep = Math.max(Math.round((tintEnd+1-tintStart)/tintStep),1);
  for (tint=tintStart;tint<=tintEnd;tint+=tintStep)
  {
     var docRef = documents.add(DocumentColorSpace.CMYK);
     var charStyle = docRef.characterStyles.add("rgbText");
     // set character attributes
     var charAttr = charStyle.characterAttributes;
     charAttr.size = 10;
     charAttr.tracking = 0;
     charAttr.capitalization = FontCapsOption.ALLCAPS;
     var textColor = new CMYKColor();
     textColor.cyan = 0;
     textColor.magenta = 0;
     textColor.yellow = 0;
     textColor.black = 100;
     charAttr.fillColor = textColor;

     if (app.documents.length == 0)
          app.documents.add(DocumentColorSpace.RGB);
 
     //rows = Number(rowsEdit.text);
     swatchLabel = "CMYK ("+tint+")";
     cyan = Number(cyanEdit.text); cyanend = Number(cyan2Edit.text);
     if (cyan>cyanend)
     {
         cyanStore = cyan;
         cyan = cyanend;
         cyanend = cyanStore;
       }
     cyanstep = Math.max(Number(cyan3Edit.text),1);
     //cyanstep = Math.round((cyanend - cyan) / (rows*cols-1));
     yel = Number(yelEdit.text); yelend = Number(yel2Edit.text); 
      if (yel>yelend) 
      {
         yelStore = yel;
         yel = yelend;
         yelend = yelStore;
       }
      yelstep =  Math.max(Number(yel3Edit.text),1);
      mag = Number(magEdit.text); magend = Number(mag2Edit.text); 
       if (mag>magend) 
      {
         magStore = mag;
         mag = magend;
         magend = magStore;
       }
      magstep =  Math.max(Number(mag3Edit.text),1);     
      blk = Number(blkEdit.text); blkend = Number(blk2Edit.text); 
       if (blk>blkend) 
      {
         blkStore = blk;
         blk = blkend;
         blkend = blkStore;
       }
      blkstep =  Math.max(Number(blk3Edit.text),1);     
      //magstep = Math.round((magend - mag) / (rows*cols-1));
      // alert( cyanstep + " " + yelstep + " " + magstep,"RGB Step");
      //Number of colors for R G and B - minimum of 1
      rows = Math.ceil(nthroot (Math.abs(cyanstep * magstep * yelstep * blkstep), 2));
      cols = rows;
      //
      cyanstep = Math.max(Math.round((cyanend + 1 - cyan)/cyanstep),1);
      yelstep = Math.max(Math.round((yelend + 1 - yel)/yelstep),1);
      magstep = Math.max(Math.round((magend + 1 - mag)/magstep),1);
      blkstep = Math.max(Math.round((blkend + 1 - blk)/blkstep),1);
      //alert( rows + " " + cols + " " + cyan + " " + yel + " " + mag +  " " + cyanstep + " " + yelstep + " " + magstep + " " + cyanend + " " + yelend + " " + magend ,"rows cols RGB Step End");
      height = app.activeDocument.height / rows;
      width = app.activeDocument.width / cols;
      // Modify Character Size
       charAttr.size = Math.round(40/cols);
      var c = cyan;
      var m = mag;
      var l = yel;
      var k = blk
     
      var x = 1
      var y = 1;
      countRect = 0;

      var color = new CMYKColor();
      for ( k=blk;k<=blkend; k+=blkstep)
           {
        for ( c=cyan;c<=cyanend; c+=cyanstep)
             {
                for ( l=yel;l<=yelend;l+=yelstep)
                  {
                        for ( m=mag;m<=magend; m+=magstep)
                        {
                            countRect++;
                            countRect=Math.min(countRect,rows*cols);
                            y =countRect%cols ;  if (y==0) y = cols;                        
                            x = Math.ceil(countRect/cols);
                            //~ alert( rows+" " +cols +" "+countRect + " " + c + " " + m + " " + y + "  " + x + " " + y,"Count CMYK xy");
                            // hsb= rgbToHsb(r,g,b);
                            color.cyan = c;
                            color.yellow = l;
                            color.magenta = m; 
                            color.black = k; 
                            rect = app.activeDocument.pathItems.rectangle (app.activeDocument.height-(y+0.1)*height, (x+0.1)*width, width*0.8, height*0.8);
                            rect.opacity = tint;
                            rect.strokeColor = black;
                            rect.strokeWidth = 0.5;
                            rect.fillColor = color;
                            t = app.activeDocument.textFrames.add();
                            charStyle.applyTo(t.textRange);
                            t.left = (x+0.5)*width;
                            t.top = app.activeDocument.height-(y+0.9)*height;
                            t.contents =  swatchLabel+"  "+c+" "+m+" "+l+" "+k;
                            t.paragraphs[0].justification = Justification.CENTER;
                            redraw();
                       }
                  }
              }
            }
         }
     
 }

if (myDlg.show()==1)
{
    showColorDialog ();
}